Index: trunk/src/VBox/Additions/WINNT/Installer/Makefile.kmk
===================================================================
--- trunk/src/VBox/Additions/WINNT/Installer/Makefile.kmk	(revision 96688)
+++ trunk/src/VBox/Additions/WINNT/Installer/Makefile.kmk	(revision 96689)
@@ -93,32 +93,31 @@
 OTHER_CLEAN += $(PATH_STAGE_BIN)/additions/VBoxWindowsAdditions-$(KBUILD_TARGET_ARCH).exe
 
-VBOX_WINDOWS_ADDITIONS_DEPS := \
-	$(PATH_STAGE_BIN)/additions/RegCleanup.exe \
+VBOX_WINDOWS_ADDITIONS_ATTESTATION_SIGNED_FILES := \
+	$(PATH_STAGE_BIN)/additions/VBoxGuest.inf \
+	$(PATH_STAGE_BIN)/additions/VBoxGuest.sys \
+	$(PATH_STAGE_BIN)/additions/VBoxTray.exe \
+	$(PATH_STAGE_BIN)/additions/VBoxControl.exe \
+       \
+	$(PATH_STAGE_BIN)/additions/VBoxMouse.inf \
 	$(PATH_STAGE_BIN)/additions/VBoxMouse.sys \
-	$(PATH_STAGE_BIN)/additions/VBoxGuest.sys \
+       \
+	$(PATH_STAGE_BIN)/additions/VBoxVideo.inf \
 	$(PATH_STAGE_BIN)/additions/VBoxVideo.sys \
 	$(PATH_STAGE_BIN)/additions/VBoxDisp.dll \
+       \
 	$(PATH_STAGE_BIN)/additions/VBoxSF.sys \
-	$(PATH_STAGE_BIN)/additions/VBoxMRXNP.dll \
-	$(PATH_STAGE_BIN)/additions/VBoxTray.exe \
-	$(PATH_STAGE_BIN)/additions/VBoxControl.exe \
-	$(PATH_STAGE_BIN)/additions/VBoxService.exe
-ifeq ($(KBUILD_TARGET_ARCH),amd64)
-# Also include 32-bit network provider DLLs on 64-bit guests to enable
-# running 32-bit apps which use that.
-VBOX_WINDOWS_ADDITIONS_DEPS += \
+	$(PATH_STAGE_BIN)/additions/VBoxMRXNP.dll
+
+ifeq ($(KBUILD_TARGET_ARCH),amd64) # 32-bit network provider DLLs for 32-bit apps running on a 64-bit system
+VBOX_WINDOWS_ADDITIONS_ATTESTATION_SIGNED_FILES += \
 	$(PATH_STAGE_BIN)/additions/VBoxMRXNP-x86.dll
 endif
-ifeq ($(KBUILD_TARGET_ARCH),x86)
-VBOX_WINDOWS_ADDITIONS_DEPS += \
-	$(PATH_STAGE_BIN)/additions/VBoxMouseNT.sys \
-	$(PATH_STAGE_BIN)/additions/VBoxSFW2K.sys
-endif
-VBOX_WINDOWS_ADDITIONS_DEPS += \
-	$(PATH_STAGE_BIN)/additions/VBoxVideo.inf \
-	$(PATH_STAGE_BIN)/additions/VBoxGuest.inf \
-	$(PATH_STAGE_BIN)/additions/VBoxMouse.inf
+
+VBOX_WINDOWS_ADDITIONS_OTHER_FILES := \
+	$(PATH_STAGE_BIN)/additions/VBoxService.exe \
+	$(PATH_STAGE_BIN)/additions/RegCleanup.exe
+
 ifdef VBOX_SIGN_ADDITIONS
-VBOX_WINDOWS_ADDITIONS_DEPS += \
+VBOX_WINDOWS_ADDITIONS_OTHER_FILES += \
 	$(PATH_STAGE_BIN)/additions/VBoxVideo.cat \
 	$(PATH_STAGE_BIN)/additions/VBoxVideo-PreW10.cat \
@@ -128,33 +127,45 @@
 	$(PATH_STAGE_BIN)/additions/VBoxMouse-PreW10.cat
 endif
+
+ifeq ($(KBUILD_TARGET_ARCH),x86)
+VBOX_WINDOWS_ADDITIONS_OTHER_FILES += \
+	$(PATH_STAGE_BIN)/additions/VBoxMouseNT.sys \
+	$(PATH_STAGE_BIN)/additions/VBoxSFW2K.sys
+endif
+ifdef VBOX_SIGN_ADDITIONS
+VBOX_WINDOWS_ADDITIONS_OTHER_FILES += \
+	$(PATH_STAGE_BIN)/additions/VBoxVideo.cat \
+	$(PATH_STAGE_BIN)/additions/VBoxVideo-PreW10.cat \
+	$(PATH_STAGE_BIN)/additions/VBoxGuest.cat \
+	$(PATH_STAGE_BIN)/additions/VBoxGuest-PreW10.cat \
+	$(PATH_STAGE_BIN)/additions/VBoxMouse.cat \
+	$(PATH_STAGE_BIN)/additions/VBoxMouse-PreW10.cat
+endif
 ifdef VBOX_WITH_WDDM
-VBOX_WINDOWS_ADDITIONS_DEPS += \
+VBOX_WINDOWS_ADDITIONS_ATTESTATION_SIGNED_FILES += \
+	$(PATH_STAGE_BIN)/additions/VBoxWddm.inf \
 	$(PATH_STAGE_BIN)/additions/VBoxWddm.sys \
-	$(PATH_STAGE_BIN)/additions/VBoxWddm.inf \
 	$(PATH_STAGE_BIN)/additions/VBoxDispD3D.dll
+ ifeq ($(KBUILD_TARGET_ARCH),amd64)
+VBOX_WINDOWS_ADDITIONS_ATTESTATION_SIGNED_FILES += \
+	$(PATH_STAGE_BIN)/additions/VBoxDispD3D-x86.dll
+ endif
+
  ifdef VBOX_WITH_WDDM_DX
-VBOX_WINDOWS_ADDITIONS_DEPS += \
+VBOX_WINDOWS_ADDITIONS_ATTESTATION_SIGNED_FILES += \
 	$(PATH_STAGE_BIN)/additions/VBoxDX.dll
+  ifeq ($(KBUILD_TARGET_ARCH),amd64)
+VBOX_WINDOWS_ADDITIONS_ATTESTATION_SIGNED_FILES += \
+	$(PATH_STAGE_BIN)/additions/VBoxDX-x86.dll
+  endif
  endif
+
  ifdef VBOX_WITH_MESA3D
-VBOX_WINDOWS_ADDITIONS_DEPS += \
+VBOX_WINDOWS_ADDITIONS_ATTESTATION_SIGNED_FILES += \
 	$(PATH_STAGE_BIN)/additions/VBoxNine.dll \
 	$(PATH_STAGE_BIN)/additions/VBoxSVGA.dll \
 	$(PATH_STAGE_BIN)/additions/VBoxGL.dll
- endif
- ifdef VBOX_SIGN_ADDITIONS
-VBOX_WINDOWS_ADDITIONS_DEPS += \
-	$(PATH_STAGE_BIN)/additions/VBoxWddm.cat \
-	$(PATH_STAGE_BIN)/additions/VBoxWddm-PreW10.cat
- endif
- ifeq ($(KBUILD_TARGET_ARCH),amd64)
-VBOX_WINDOWS_ADDITIONS_DEPS += \
-	$(PATH_STAGE_BIN)/additions/VBoxDispD3D-x86.dll
-  ifdef VBOX_WITH_WDDM_DX
-VBOX_WINDOWS_ADDITIONS_DEPS += \
-	$(PATH_STAGE_BIN)/additions/VBoxDX-x86.dll
-  endif
-  ifdef VBOX_WITH_MESA3D
-VBOX_WINDOWS_ADDITIONS_DEPS += \
+  ifeq ($(KBUILD_TARGET_ARCH),amd64)
+VBOX_WINDOWS_ADDITIONS_ATTESTATION_SIGNED_FILES += \
 	$(PATH_STAGE_BIN)/additions/VBoxNine-x86.dll \
 	$(PATH_STAGE_BIN)/additions/VBoxSVGA-x86.dll \
@@ -162,8 +173,14 @@
   endif
  endif
+
+ ifdef VBOX_SIGN_ADDITIONS
+VBOX_WINDOWS_ADDITIONS_OTHER_FILES += \
+	$(PATH_STAGE_BIN)/additions/VBoxWddm.cat \
+	$(PATH_STAGE_BIN)/additions/VBoxWddm-PreW10.cat
+ endif
 endif
 
 ifdef env.VBOX_WITH_ADDITIONS_SHIPPING_AUDIO_TEST
-VBOX_WINDOWS_ADDITIONS_DEPS += \
+VBOX_WINDOWS_ADDITIONS_OTHER_FILES += \
 	$(PATH_STAGE_BIN)/additions/VBoxAudioTest.exe
 endif
@@ -210,5 +227,6 @@
 		$(PATH_SUB_CURRENT)/VBoxGuestAdditionsVista.nsh \
 		$(PATH_SUB_CURRENT)/VBoxGuestAdditionsNT4.nsh \
-		$(VBOX_WINDOWS_ADDITIONS_DEPS) \
+		$(VBOX_WINDOWS_ADDITIONS_ATTESTATION_SIGNED_FILES) \
+		$(VBOX_WINDOWS_ADDITIONS_OTHER_FILES) \
 		$(VBOX_WINDOWS_ADDITIONS_ICON_FILE) \
 		$(VBOX_NSIS_ICON_FILE) \
@@ -218,5 +236,5 @@
 		$$(VBoxDrvInst_1_STAGE_TARGET)
 	$(call MSG_L1,Creating $@, from $<)
-ifdef VBOX_GA_ATTESTATION_SIGNING # Unpack the attestation signed drivers
+ifdef VBOX_GA_ATTESTATION_SIGNING # Unpack the attestation signed drivers - this is an ugly has 'ing heck hack!
 	$(TOOL_ZIP_UNPACK) -voj $(PATH_OUT)/repackadd/$(VBOX_SIGNED_DRIVERS_ZIP_NAME) -d $(PATH_STAGE_BIN)/additions/
 endif
@@ -251,5 +269,6 @@
 		$(PATH_SUB_CURRENT)/VBoxGuestAdditionsVista.nsh \
 		$(PATH_SUB_CURRENT)/VBoxGuestAdditionsNT4.nsh \
-		$(VBOX_WINDOWS_ADDITIONS_DEPS) \
+		$(VBOX_WINDOWS_ADDITIONS_ATTESTATION_SIGNED_FILES) \
+		$(VBOX_WINDOWS_ADDITIONS_OTHER_FILES) \
 		$(VBOX_WINDOWS_ADDITIONS_ICON_FILE) \
 		$(VBOX_NSIS_ICON_FILE) \
@@ -293,5 +312,6 @@
 #
 $(PATH_OUT)/repackadd/$(VBOX_DRIVERS_PACK_NAME): \
-		$(PATH_OUT)/repackadd/PackDriversForSubmission.cmd ## @todo r=bird: Missing almost all driver file dependencies.
+		$(PATH_OUT)/repackadd/PackDriversForSubmission.cmd \
+#		$(VBOX_WINDOWS_ADDITIONS_ATTESTATION_SIGNED_FILES) - is is unsafe, because of the 'ing ugly hack replacing most of them above during packing.
 	$(RM_EXT) -f $(PATH_OUT)/repackadd/*.cab
 	$(RM_EXT) -f $(PATH_OUT)/repackadd/*.ddf